if(!isObject(colorPickerGui))
{
	new GuiControl(colorPickerGui) 
	{
   		profile = "GuiDefaultProfile";
   		horizSizing = "right";
   		vertSizing = "bottom";
  		position = "0 0";
   		extent = "144 144";
   		minExtent = "8 2";
   		enabled = "1";
   		visible = "1";
   		clipToParent = "1";
		closecommand = "exitColorPicker();";
		command = "exitColorPicker();";
		accelerator = "escape";
	};
}

function colorPicked(%i)
{
	canvas.popDialog(colorPickerGui);
	colorPicker.source.picked = %i;
	colorPicker.source.color = getColorI(getColorIDTable(%i));
	for(%a=0;%a<colorPicker.getcount();%a++)
	{
		colorPicker.getObject(%a).getObject(0).delete();
		colorPicker.getObject(%a).delete();
	}
	colorPicker.delete();
}

function exitColorPicker()
{
	canvas.popDialog(colorPickerGui);
	for(%a=0;%a<colorPicker.getcount();%a++)
	{
		colorPicker.getObject(%a).getObject(0).delete();
		colorPicker.getObject(%a).delete();
	}
	colorPicker.delete();
}

function colorPicker(%sourceSwatch,%parent,%hideTrans,%pos)
{
	if(isObject(colorPicker))
		colorPicker.delete();
	if(isObject(colorPicker))
		colorPicker.delete();

      	new GuiSwatchCtrl(colorPicker) 
	{
         profile = "GuiDefaultProfile";
         horizSizing = "right";
         vertSizing = "bottom";
         position = %pos;
         extent = "144 144";
         minExtent = "144 144";
         enabled = "1";
         visible = "1";
         clipToParent = "1";
         color = "150 150 150 255";
	};

	colorPicker.source = %sourceSwatch;
	colorPickerGui.add(colorPicker);

	%id = 0;
	%a = 0;
	%b = 0;
	for(%id=0;%id<64;%id++)
	{
		if(%hideTrans && isTrans(%id))
		{

		}
		else
		{
			%swatch = new GuiSwatchCtrl() 
			{
        	 		profile = "GuiDefaultProfile";
         			horizSizing = "right";
        	 		vertSizing = "bottom";
        	 		position = %a*18 SPC %b*18;
        	 		extent = "16 16";
        	 		minExtent = "16 16";
        	 		enabled = "1";
        			visible = "1";
        	 		clipToParent = "1";
				id = %id;
        	 		color = getColorI(getColorIDTable(%id));
			};
          		%button = new GuiBitmapButtonCtrl() 
			{
				bitmap = "add-ons/system_eventing/ui/checker";
               			profile = "GuiDefaultProfile";
               			horizSizing = "right";
               			vertSizing = "bottom";
               			position = "0 0";
               			extent = "16 16";
               			minExtent = "8 2";
               			enabled = "1";
               			visible = "1";
               			clipToParent = "1";
               			command = "colorPicked(" @ %id @ ");";
               			text = " ";
               			groupNum = "-1";
               			buttonType = "PushButton";
               			lockAspectRatio = "0";
               			alignLeft = "0";
               			alignTop = "0";
               			overflowImage = "0";
               			mKeepCached = "0";
               			mColor = "255 255 255 " @ getWord(getColorI(getColorIDTable(%id)),3)-255;
            		};
			%swatch.add(%button);
			colorPicker.add(%swatch);
			%a++;
			if(%a > 7)
			{
				%a = 0;
				%b++;
			}
		}
	}

	canvas.pushDialog(colorPickerGui);
}

function isTrans(%color)
{
	return getword(getcolorI(getColorIDTable(%color)),3) < 255;
}



